C--- RETURN(Sum( fi(x1)*fj(x2)*x1*x2)) 
      subroutine lumif(collider,x1,x2, isetval, Lgg,Lqgt,
     &          Lqqbt,Lqq,Lq1q2,Lbb,Lbbbar,Lbq,Lbg,Lqqbar_no_b,
     &          Luub,Lddb,Lug,Ldg)
      implicit none
      integer isetval
      double precision x1,x2
      double precision Lgg,Lqg,Lgq, Lqbq, Lqqb,Lqq,Lq1q2
      double precision mq_light1,mqb_light1,mq_light2,mqb_light2
      double precision Lbb,Lbbbar,Lbq,Lbg,Lqqbar_no_b
	double precision Luub,Lddb,Lug,Ldg ! for ewk corrections
      character*60 collider      
      double precision upv1,dnv1,usea1,dsea1,str1,chm1,bot1,glu1
      double precision upv2,dnv2,usea2,dsea2,str2,chm2,bot2,glu2
      double precision mu1, md1, ms1, mc1, mb1, mub1, mdb1, msb1 
      double precision mcb1, mbb1
      double precision mu2, md2, ms2, mc2, mb2, mub2, mdb2, msb2 
      double precision mcb2, mbb2, Lqgt, Lqqbt
      external mypdf
	integer aspdfset

      if ((x1.gt.1d0).or.(x2.gt.1d0)) then 

      Lgg = 0d0
      Lqgt= 0d0
      Lqqbt = 0d0
      Lqq = 0d0
      Lq1q2 = 0d0
      Lbb = 0d0
      Lbbbar = 0d0
      Lbq = 0d0
      Lbg = 0d0
      Lqqbar_no_b  = 0d0
	Luub=0d0
	Lddb=0d0
	Lug=0d0
	Ldg=0d0
      else

	!call test_against_known_pdfs(x1,muf,pdfset)
	
c--------------------------------------------------------------------
c			PDF callers
c--------------------------------------------------------------------
c	: directly from MSTW grids. 
c	: It assumes pdfset is the name of the
c	: set and that the path to the grids is known
c	: see pdfset.F
c      call mypdf(x1,muf,pdfset, isetval, upv1,dnv1,usea1,dsea1,str1,
c     &           chm1,bot1,glu1)


c      call mypdf(x2,muf,pdfset, isetval, upv2,dnv2,usea2,dsea2,str2,
c     &           chm2,bot2,glu2)


c--------------------------------------------------------------------
c	: from lhapdf interface with interpolation routines by Franz
c	: It assumes init_pdfaserror is called from hggtotal @ main.F
c	: see pdf/LHAPDF_ERRORS_FITTING

	!: aspdfset determines which as set is to be used from those
	!: that have already been initialized when calling 
	!: init_pdfserror
	aspdfset=1

	call my_interpolated_pdf(x1,aspdfset, isetval, upv1,
     &		dnv1,usea1,dsea1,str1,
     &		chm1,bot1,glu1)

      call my_interpolated_pdf(x2,aspdfset, isetval, upv2,
     &		dnv2,usea2,dsea2,str2,
     &           chm2,bot2,glu2)

c--------------------------------------------------------------------
c	: from lhapdf with direct calling
c	: It assumes InitPDFsetByName for the set *AND* InitPDF(member)
c	: for the member are both called 
c	: (outside the MC loop, otherwise it would be too slow)

c	call my_lha_pdfs(x1,muf,aspdfset, isetval, upv1,
c     &		dnv1,usea1,dsea1,str1,
c     &		chm1,bot1,glu1)
	
	
c      call my_lha_pdfs(x2,muf,aspdfset, isetval, upv2,
c     &		dnv2,usea2,dsea2,str2,
c     &           chm2,bot2,glu2)
c--------------------------------------------------------------------

      if (collider.eq.'LHC') then 
         mu1 = upv1 + usea1
         md1 = dnv1 + dsea1
         ms1 = str1
         mc1 = chm1 
         mb1 = bot1
         mub1 = usea1
         mdb1 = dsea1
         msb1 = str1
         mcb1 = chm1 
         mbb1 = bot1

         mu2 = upv2 + usea2
         md2 = dnv2 + dsea2
         ms2 = str2
         mc2 = chm2 
         mb2 = bot2
         mub2 = usea2
         mdb2 = dsea2
         msb2 = str2
         mcb2 = chm2 
         mbb2 = bot2

      elseif (collider.eq.'TEVATRON') then 
         mu1 = upv1 + usea1
         md1 = dnv1 + dsea1
         ms1 = str1
         mc1 = chm1 
         mb1 = bot1
         mub1 = usea1
         mdb1 = dsea1
         msb1 = str1
         mcb1 = chm1 
         mbb1 = bot1

         mu2 = usea2
         md2 = dsea2
         ms2 = str2
         mc2 = chm2 
         mb2 = bot2
         mub2 = upv2 + usea2
         mdb2 = dnv2 + dsea2
         msb2 = str2
         mcb2 = chm2 
         mbb2 = bot2
	else
		print*,"[lumif] ERROR: unrecognized collider:",collider
		mu1 = 0d0
         md1 = 0d0
         ms1 = 0d0
         mc1 = 0d0 
         mb1 = 0d0
         mub1 = 0d0
         mdb1 = 0d0
         msb1 = 0d0
         mcb1 = 0d0 
         mbb1 = 0d0

         mu2 = 0d0
         md2 = 0d0
         ms2 = 0d0
         mc2 = 0d0 
         mb2 = 0d0
         mub2 = 0d0
         mdb2 = 0d0
         msb2 = 0d0
         mcb2 = 0d0 
         mbb2 = 0d0
	   stop
      endif

      Lgg = glu1*glu2

      Lgq = glu1*(mu2+md2+ms2+mc2+mb2+
     &            mub2+mdb2+msb2+mcb2+mbb2)

      Lqg = glu2*(mu1+md1+ms1+mc1+mb1+
     &            mub1+mdb1+msb1+mcb1+mbb1)

      Lqgt= Lqg+Lgq

      Lqqb = mu1*mub2+md1*mdb2+ms1*msb2+mc1*mcb2+
     &       mb1*mbb2

      Lqbq = mu2*mub1+md2*mdb1+ms2*msb1+mc2*mcb1+
     &       mb2*mbb1

      Lqqbt = Lqqb + Lqbq


      Lqq =  mu1*mu2+md1*md2+ms1*ms2+mc1*mc2+
     &       mb1*mb2+
     &       mub1*mub2+mdb1*mdb2+msb1*msb2+mcb1*mcb2+
     &       mbb1*mbb2


      Lq1q2 =  (mu1+mub1)*(md2+ms2+mc2+mb2+mdb2+msb2+mcb2+mbb2)
     &        +(md1+mdb1)*(mu2+ms2+mc2+mb2+mub2+msb2+mcb2+mbb2)
     &        +(mc1+mcb1)*(mu2+ms2+md2+mb2+mub2+msb2+mdb2+mbb2)
     &        +(ms1+msb1)*(mu2+md2+mc2+mb2+mub2+mdb2+mcb2+mbb2)
     &        +(mb1+mbb1)*(mu2+ms2+mc2+md2+mub2+msb2+mcb2+mdb2)

c	luminosities for the electroweak corrections: up type / down type specific
	Luub = mu1*mub2+mc1*mcb2+mu2*mub1+mc2*mcb1
	
	Lddb = md1*mdb2+ms1*msb2+ mb1*mbb2+md2*mdb1+ms2*msb1+ mb2*mbb1
	
	Lug = glu1*(mu2+mc2+mub2+mcb2) + glu2*(mu1+mc1+mub1+mcb1)
	
	Ldg = glu1*(md2+ms2+mb2+mdb2+msb2+mbb2) 
     &	+ glu2*(md1+ms1+mb1+mdb1+msb1+mbb1)

      
c     luminosities for the b b-bar initial state
      !: light = u + d + c + s
      mq_light1 = mu1+md1+mc1+ms1
      mqb_light1= mub1+mdb1+mcb1+msb1
      mq_light2 = mu2+md2+mc2+ms2
      mqb_light2= mub2+mdb2+mcb2+msb2
      
      Lbbbar = mb1*mbb2 + mb2*mbb1
      
      Lbb = mb1*mb2 + mbb1*mbb2
      
      Lbq = (mb1+mbb1)*(mq_light2+mqb_light2) 
     $    + (mb2+mbb2)*(mq_light1+mqb_light1)
      
      Lbg = glu1*(mb2+mbb2)+glu2*(mb1+mbb1)
      
      Lqqbar_no_b = mq_light1*mqb_light2+mqb_light1*mq_light2
     $              +mq_light1*mq_light2+mqb_light1*mqb_light2
      
      Lqqbar_no_b = mu1*mub2+mu2*mub1 +
     $              md1*mdb2+md2*mdb1 +
     $              mc1*mcb2+mc2*mcb1 +
     $              ms1*msb2+ms2*msb1 
      endif

      END
	
	
	
	
c	subroutine test_against_known_pdfs(x1,muf,pdfset)
c	implicit none
c	character*60 pdfset
c	integer aspdfset,isetval
c	double precision Xupv1,Xdnv1,Xusea1,Xdsea1,Xstr1,
c     &           Xchm1,Xbot1,Xglu1
c	double precision upv1,dnv1,usea1,dsea1,str1,
c     &           chm1,bot1,glu1
c	double precision max_error,x1,muf
c	aspdfset = 1
c	isetval = 0
c	max_error= 1e-3
c	
c	call mypdf(x1,muf,pdfset, isetval, 
c     &	upv1,dnv1,usea1,dsea1,str1,
c     &           chm1,bot1,glu1)
c
c	
c	call my_interpolated_pdf(x1,aspdfset, isetval, Xupv1,
c     &		Xdnv1,Xusea1,Xdsea1,Xstr1,
c     &		Xchm1,Xbot1,Xglu1)
c
c	call precision_if(glu1,Xglu1,max_error,x1,"glu")
c	call precision_if(upv1,Xupv1,max_error,x1,"upv")
c	call precision_if(dnv1,Xdnv1,max_error,x1,"dnv")
c	call precision_if(usea1,Xusea1,max_error,x1,"usea")
c	call precision_if(dsea1,Xdsea1,max_error,x1,"dsea")
c	call precision_if(str1,Xstr1,max_error,x1,"str")
c	call precision_if(chm1,Xchm1,max_error,x1,"chm")
c	call precision_if(bot1,Xbot1,max_error,x1,"bot")
c	
c	
c	end 
c	
c	subroutine precision_if(xx,yy,max_error,x1,flavour)
c	implicit none
c	character*4 flavour
c	double precision xx,yy,max_error,x1
c	if ((dabs(xx-yy)/xx.gt.max_error).and.(xx.GT.1e-5)) then
c	print*,"* ",flavour," x=",x1," d_pdf=",dabs(xx-yy)/xx,
c     &		xx,yy
c	endif
c	end
	
	
	
	
	
	
	
	
	
	

